#include <stdio.h>
#include "pen4_vc.h"
#include "pen4_vc_str.h"

//**********************************************************
//ЂȂ(𗎂Ƃ) sJnO̓
//@
//@@servo_wav2F[Vf[^
//@@leg_prmFrp\
//@@arm_prmFrp\
//@@body_prmF̗p\
//@@step_infF[Vf[^ʃp[^p\
//@@*cog_pathFoH̕ێp\
//@@arm_angFr֐߂̊px
//@߂l
//@@[Vf[^̃f[^
//**********************************************************
int wave_sit01(int servo_wav2[WAVE_MAX][12], struct LEG_PRM leg_prm[2], struct ARM_PRM arm_prm[2],
			struct BODY_PRM body_prm, struct STEP_INF step_inf, struct COG_PATH *cog_path,
			double arm_ang[2][3])
{
int     i, j, k;
int     data_num2;

double	coo_wav1[2][WAVE_MAX][3];
double	angle2[WAVE_MAX][2][2];


	//*********************************************************************************
	//̏ʒuZbg
	for(i = 0; i < 2; i++)
	{
		cog_path->start_coo[i][0] = step_inf.offset[i][0];
		cog_path->start_coo[i][1] = step_inf.offset[i][1];
		cog_path->start_coo[i][2] = step_inf.offset[i][2] + 0.1;
	}

	cog_path->COG_coo[0] = step_inf.init_offset;
	cog_path->COG_coo[1] = 0.0;
	cog_path->COG_coo[2] = -step_inf.init_depth;
	cog_path->point_num = step_inf.point_num;

	//O
	data_num2 = COG_move1(cog_path, coo_wav1);

	//O_t@Cɏoi`FbNpj
	i = coo_fwrite("pen4_coo.csv", coo_wav1, data_num2);

	//O_qbT[{o̓f[^i[Vf[^jɕϊ
	i = orbit2servo_wav1(coo_wav1, angle2, servo_wav2, data_num2, leg_prm);

	//Ƙr̃f[^ẘpx̃f[^Ŗ߂
	for(i = 0; i < data_num2; i++)
	{
		//
		k = 0;
		for(j = 4; j < 6; j++)
		{
			servo_wav2[i][j] = angle2servo2(k, 0.0, body_prm);
			k++;
		}
		//Er
		k = 0;
		for(j = 6; j < 9; j++)
		{
			servo_wav2[i][j] = angle2servo3(k, arm_ang[0][k], arm_prm[0]);
			k++;
		}
		//r
		k = 0;
		for(j = 9; j < 12; j++)
		{
			servo_wav2[i][j] = angle2servo3(k, arm_ang[1][k], arm_prm[1]);
			k++;
		}
	}

	return(data_num2);
}


//**********************************************************
//ЂL΂(グ)
//@
//@@servo_wav2F[Vf[^
//@@leg_prmFrp\
//@@arm_prmFrp\
//@@body_prmF̗p\
//@@step_infF[Vf[^ʃp[^p\
//@@*cog_pathFoH̕ێp\
//@@arm_angFr֐߂̊px
//@߂l
//@@[Vf[^̃f[^
//**********************************************************
int wave_stand01(int servo_wav2[WAVE_MAX][12], struct LEG_PRM leg_prm[2], struct ARM_PRM arm_prm[2],
			struct BODY_PRM body_prm, struct STEP_INF step_inf, struct COG_PATH *cog_path,
			double arm_ang[2][3])
{
int     i, j, k;
int     data_num2;

double	coo_wav1[2][WAVE_MAX][3];
double	angle2[WAVE_MAX][2][2];


	//*********************************************************************************
	//̏ʒuZbg
	for(i = 0; i < 2; i++)
	{
		cog_path->start_coo[i][0] = step_inf.offset[i][0];
		cog_path->start_coo[i][1] = step_inf.offset[i][1];
		cog_path->start_coo[i][2] = step_inf.offset[i][2] + 0.1;
	}

	cog_path->COG_coo[0] = -step_inf.init_offset;
	cog_path->COG_coo[1] = 0.0;
	cog_path->COG_coo[2] = step_inf.init_depth;
	cog_path->point_num = step_inf.point_num;

	//O
	data_num2 = COG_move1(cog_path, coo_wav1);
	//O_qbT[{o̓f[^i[Vf[^jɕϊ
	i = orbit2servo_wav1(coo_wav1, angle2, servo_wav2, data_num2, leg_prm);

	//㔼gƘr̃f[^ẘpx̃f[^Ŗ߂
	for(i = 0; i < data_num2; i++)
	{
		//
		k = 0;
		for(j = 4; j < 6; j++)
		{
			servo_wav2[i][j] = angle2servo2(k, 0.0, body_prm);
			k++;
		}
		//Er
		k = 0;
		for(j = 6; j < 9; j++)
		{
			servo_wav2[i][j] = angle2servo3(k, arm_ang[0][k], arm_prm[0]);
			k++;
		}
		//r
		k = 0;
		for(j = 9; j < 12; j++)
		{
			servo_wav2[i][j] = angle2servo3(k, arm_ang[1][k], arm_prm[1]);
			k++;
		}
	}

	return(data_num2);
}

//**********************************************************
//@L̋O_
//@
//@@*cog_pathFoH̕ێp\
//@@coo_wav1FO_
//@߂l
//@@O_̃f[^
//**********************************************************
int COG_move1(struct COG_PATH *cog_path, double coo_wav1[2][WAVE_MAX][3])
{
int			i, j, num;
struct		FOOT_PATH foot_path[2];


	for(i = 0; i < 2; i++)//@i=0@EAi=1@
	{
		for(j = 0; j < 3; j++)
		{
			foot_path[i].coo[0][j] = cog_path->start_coo[i][j];//Jnʒu
			foot_path[i].coo[1][j] = foot_path[i].coo[0][j] 
											- cog_path->COG_coo[j];//Iʒu
		}
		foot_path[i].point_num = cog_path->point_num;
		num = orbit_strait1b(foot_path[i], coo_wav1[i]);
	}
	return(num);
}

//*************************************************************
//@rT[{p̃f[^Vtg
//@T[{f[^ɃVtgBi㔼g̐UoȂǁj
//@
//@@servo_wav2:[Vf[^
//@@total_data_num:Vtg̃[Vf[^̃f[^
//@@start_ptr:Vtg
//@@valid_data_num:VtgÕ[Vf[^̃f[^
//@߂l
//@@
//*************************************************************
void wave_shift1(int servo_wav2[WAVE_MAX][12], int total_data_num,
				 int start_ptr, int valid_data_num)
{
int		i, j, ptr2;
int servo_wav_work[WAVE_MAX][12];


	//f[^̑SRs[
	for(i = 0; i < total_data_num; i++)
	{
		for(j = 0; j < 12; j++)
		{
			servo_wav_work[i][j] = servo_wav2[i][j];
		}
	}

	//rf[^ɂăVtgꏊOf[^Ŗ߂
	for(i = 0; i < start_ptr; i++)
	{
		for(j = 0; j < 4; j++)
		{
			servo_wav_work[i][j] = servo_wav2[0][j];
		}
	}

	//f[^Rs[
	ptr2 = 0;
	for(i = start_ptr; i < start_ptr + valid_data_num; i++)
	{
		for(j = 0; j < 4; j++)
		{
			servo_wav_work[i][j] = servo_wav2[ptr2][j];
		}
		ptr2++;
	}

	//rf[^ɂăVtgꏊŏIf[^Ŗ߂
	for(i = start_ptr + valid_data_num; i < total_data_num; i++)
	{
		for(j = 0; j < 4; j++)
		{
			servo_wav_work[i][j] = servo_wav2[valid_data_num - 1][j];
		}
	}

	//̔zɃRs[
	//f[^̑SRs[
	for(i = 0; i < total_data_num; i++)
	{
		for(j = 0; j < 12; j++)
		{
			servo_wav2[i][j] = servo_wav_work[i][j];
		}
	}
}
