#include "pen4_vc.h"
#include <stdio.h>
#include <string.h>
#include "pen4_vc_str.h"
#include "pen4_vc_class.h"

//**********************************************************
//@s[Vf[^ꊇ쐬
//@
//@@body_prmF̗p\
//@@arm_prmFrp\
//@@leg_prmFrp\
//@߂l
//@@
//**********************************************************
void create_waveset1(struct BODY_PRM body_prm, struct ARM_PRM arm_prm[2], struct LEG_PRM leg_prm[2])
{
    int     id, data_num;
    int     servo_wav2[WAVE_MAX][12];
    char    comment[256];
    double  arm_ang[2][3], swing_arm_ang;

    struct  STEP_INF step_inf;
    struct  COG_PATH cog_path;

    class   Walk01 walk01;
    class   Walk02 walk02;

    //[Vf[^t@C`
    //strcpy(wavef_name_wave, "pen4_mot.csv");

    //r֐߈ʒu
    arm_ang[0][0] = -15.0 / 180.0 * PI;// SV6
    arm_ang[0][1] = -35.0 / 180.0 * PI;// SV7
    arm_ang[0][2] =  70.0 / 180.0 * PI;// SV8
    arm_ang[1][0] =  15.0 / 180.0 * PI;// SV9
    arm_ang[1][1] =  35.0 / 180.0 * PI;// SV10
    arm_ang[1][2] = -70.0 / 180.0 * PI;// SV11

    //**************************************************************************
    //qŰL@sJnƕsĨ[V
    //ʒũItZbgZbg
    //iE̋r̒ɑ傫Ȍ덷͂ɐlĒ߂j
    step_inf.offset[0][0]   =  0.0;//x right
    step_inf.offset[1][0]   =  0.0;//x left
    step_inf.offset[0][1]   =  0.0;//y right
    step_inf.offset[1][1]   =  0.0;//y left
    step_inf.offset[0][2]   =  0.0;//z right
    step_inf.offset[1][2]   =  0.0;//z left

    //𗎂ƂZbg
    step_inf.init_depth     = 3.0;
    //𗎂Ƃ̂wiOjItZbgZbg
    //qUȂɃqU֐߂ւׂ̕ς鎖ɂA֐߂̐΍
    //ςAdSĂ܂ۂ⏞邽߂̐lZbg
    step_inf.init_offset    = 4.0;
    //[Ṽ|CgZbg
    step_inf.point_num      = 30;

    id = 0;//0
    printf("id = %d\n", id);
    //[Vf[^̃RgZbg
    strcpy(comment, "stand lower");
    //[Vf[^
    data_num = wave_sit01           (servo_wav2, leg_prm, arm_prm, body_prm, step_inf, &cog_path, arm_ang);
    //[Vf[^t@Cɏށit@C͐VK쐬j
    savo_fwrite("0.csv", servo_wav2, data_num);

    //ʒũItZbgZbg
    step_inf.offset[0][0]   =-step_inf.init_offset;//x right
    step_inf.offset[1][0]   =-step_inf.init_offset;//x left
    step_inf.offset[0][1]   =  0.0;//y right
    step_inf.offset[1][1]   =  0.0;//y left
    step_inf.offset[0][2]   =  step_inf.init_depth;//z right
    step_inf.offset[1][2]   =  step_inf.init_depth;//z left

    id++;//1
    printf("id = %d\n", id);
    //[Vf[^̃RgZbg
    strcpy(comment, "stand higher");
    //[Vf[^
    data_num = wave_stand01         (servo_wav2, leg_prm, arm_prm, body_prm, step_inf, &cog_path, arm_ang);
    //[Vf[^t@Cɏށit@C͂ȍ~ǉ݁j
    savo_fwrite("1.csv", servo_wav2, data_num);

    //**************************************************************************
    //iiOij̃[V
    //㔼gUpxixPʁj
    step_inf.swingL         =  13.0;
    step_inf.swingR         = -13.0;
    //~̍
    step_inf.v_diff         = 12.0;
    // iPʁj
    step_inf.travel         = 30.0;
    //TCÑ|Cg
    step_inf.point_num      = 17;
    //ɐڒn|Cg
    step_inf.overlap_num    = 0;

    swing_arm_ang = 20.0;

    id++;//2
    printf("id = %d\n", id);
    strcpy(comment, "forward");
    data_num = walk01.for_cont      (servo_wav2, leg_prm, arm_prm, body_prm, &step_inf, arm_ang);
    //data_num = walk01.forturnL_cont   (servo_wav2, leg_prm, arm_prm, body_prm, &step_inf, arm_ang);
    //data_num = walk01.forturnR_cont   (servo_wav2, leg_prm, arm_prm, body_prm, &step_inf, arm_ang);
    walk0_swingarm1(servo_wav2, arm_prm, arm_ang[1][1], swing_arm_ang, step_inf.point_num, step_inf.point_num, 0);
    savo_fwrite("2.csv", servo_wav2, data_num);

    id++;//3
    printf("id = %d\n", id);
    strcpy(comment, "forward first step");
    data_num = walk01.for_first     (servo_wav2, leg_prm, arm_prm, body_prm, &step_inf, arm_ang);
    walk0_swingarm2(servo_wav2, arm_prm, arm_ang[1][1], -swing_arm_ang, step_inf.point_num, step_inf.point_num, step_inf.point_num / 2);
    savo_fwrite("3.csv", servo_wav2, data_num);

    id++;//4
    printf("id = %d\n", id);
    strcpy(comment, "forward last step");
    data_num = walk01.for_last      (servo_wav2, leg_prm, arm_prm, body_prm, &step_inf, arm_ang);
    walk0_swingarm3(servo_wav2, arm_prm, arm_ang[1][1], swing_arm_ang, step_inf.point_num, step_inf.point_num, 0);
    savo_fwrite("4.csv", servo_wav2, data_num);

    //**************************************************************************
    //iiij̃[V
    step_inf.swingL         =  12.0;
    step_inf.swingR         = -12.0;
    step_inf.v_diff         = 12.0;
    step_inf.travel         = 20.0;
    step_inf.point_num      = 17;
    step_inf.overlap_num    = 0;

    swing_arm_ang = -20.0;

    id++;//5
    printf("id = %d\n", id);
    strcpy(comment, "backward");
    data_num = walk01.back_cont     (servo_wav2, leg_prm, arm_prm, body_prm, &step_inf, arm_ang);
    //walk0_swingarm1(servo_wav2, arm_prm, arm_ang[1][1], swing_arm_ang, step_inf.point_num, step_inf.point_num, 0);
    savo_fwrite("5.csv", servo_wav2, data_num);

    id++;//6
    printf("id = %d\n", id);
    strcpy(comment, "backward first step");
    data_num = walk01.back_first        (servo_wav2, leg_prm, arm_prm, body_prm, &step_inf, arm_ang);
	//r̐UƂQԃT[{̃f[^Ȃ̂łƂ肠RgAEg 2013/06/24
    //walk0_swingarm2(servo_wav2, arm_prm, arm_ang[1][1], -swing_arm_ang, step_inf.point_num, step_inf.point_num, step_inf.point_num / 2);
    savo_fwrite("6.csv", servo_wav2, data_num);

    id++;//7
    printf("id = %d\n", id);
    strcpy(comment, "backward last step");
    data_num = walk01.back_last     (servo_wav2, leg_prm, arm_prm, body_prm, &step_inf, arm_ang);
    //walk0_swingarm3(servo_wav2, arm_prm, arm_ang[1][1], swing_arm_ang, step_inf.point_num, step_inf.point_num, 0);
    savo_fwrite("7.csv", servo_wav2, data_num);
    //**************************************************************************
    //Mñ[V
    step_inf.swingL         =  12.0;
    step_inf.swingR         = -12.0;
    step_inf.v_diff         = 10.0;
    step_inf.travel         = 30.0;
    step_inf.overlap_num    = 0;

    //Mnij̃[V
    step_inf.point_num      = 17;
    id++;//8
    printf("id = %d\n", id);
    strcpy(comment, "left turn first step");
    data_num = walk02.turnL_first       (servo_wav2, leg_prm, arm_prm, body_prm, &step_inf, arm_ang);
    savo_fwrite("8.csv", servo_wav2, data_num);

    step_inf.point_num      = 20;
    id++;//9
    printf("id = %d\n", id);
    strcpy(comment, "left turn last step");
    data_num = walk02.turnL_last        (servo_wav2, leg_prm, arm_prm, body_prm, &step_inf, arm_ang);
    savo_fwrite("9.csv", servo_wav2, data_num);

    //MniEj̃[V
    step_inf.point_num      = 17;
    id++;//10
    printf("id = %d\n", id);
    strcpy(comment, "right turn first step");
    data_num = walk02.turnR_first       (servo_wav2, leg_prm, arm_prm, body_prm, &step_inf, arm_ang);
    savo_fwrite("10.csv", servo_wav2, data_num);

    step_inf.point_num      = 20;
    id++;//11
    printf("id = %d\n", id);
    strcpy(comment, "right turn last step");
    data_num = walk02.turnR_last        (servo_wav2, leg_prm, arm_prm, body_prm, &step_inf, arm_ang);
    savo_fwrite("11.csv", servo_wav2, data_num);

    //*******************************************************************
    //big radius turniOij̃[V
    //㔼gUpxixPʁj
    step_inf.swingL         =  13.0;
    step_inf.swingR         = -13.0;
    //~̍
    step_inf.v_diff         = 12.0;
    // iPʁj
    step_inf.travel         = 30.0;
    //TCÑ|Cg
    step_inf.point_num      = 17;
    //ɐڒn|Cg
    step_inf.overlap_num    = 0;

    swing_arm_ang = 20.0;
    id++;//12
    printf("id = %d\n", id);
    strcpy(comment, "forward");
    data_num = walk01.forturnR_cont   (servo_wav2, leg_prm, arm_prm, body_prm, &step_inf, arm_ang);
    walk0_swingarm1(servo_wav2, arm_prm, arm_ang[1][1], swing_arm_ang, step_inf.point_num, step_inf.point_num, 0);
    savo_fwrite("12.csv", servo_wav2, data_num);

    id++;//13
    printf("id = %d\n", id);
    strcpy(comment, "forward");
    data_num = walk01.forturnL_cont   (servo_wav2, leg_prm, arm_prm, body_prm, &step_inf, arm_ang);
    walk0_swingarm1(servo_wav2, arm_prm, arm_ang[1][1], swing_arm_ang, step_inf.point_num, step_inf.point_num, 0);
    savo_fwrite("13.csv", servo_wav2, data_num);
    //**************************************************************************
    //Mni񗦁@j̃[V
    step_inf.swingL         =  16.0;
    step_inf.swingR         = -16.0;
    step_inf.v_diff         = 10.0;
    step_inf.travel         = 30.0;
    step_inf.overlap_num    = 0;

    //Mnij̃[V
	step_inf.point_num      = 17;//Vr|Cg
    step_inf.point_num2     = 32;//Xbv|Cg
    id++;//14
    printf("id = %d\n", id);
    strcpy(comment, "rapid left turn cont. step");
    data_num = walk02.turnL_cont2      (servo_wav2, leg_prm, arm_prm, body_prm, &step_inf, arm_ang);
    savo_fwrite("14.csv", servo_wav2, data_num);

    step_inf.point_num      = 17;
    id++;//15
    printf("id = %d\n", id);
    strcpy(comment, "rapid left turn first step");
    data_num = walk02.turnL_first2    (servo_wav2, leg_prm, arm_prm, body_prm, &step_inf, arm_ang);
    savo_fwrite("15.csv", servo_wav2, data_num);

	step_inf.point_num      = 17;
    id++;//16
    printf("id = %d\n", id);
    strcpy(comment, "rapid left turn last step");
    data_num = walk02.turnL_last2      (servo_wav2, leg_prm, arm_prm, body_prm, &step_inf, arm_ang);
    savo_fwrite("16.csv", servo_wav2, data_num);

    //MniEj̃[V
	step_inf.point_num      = 17;//Vr|Cg
    step_inf.point_num2     = 32;//Xbv|Cg
    id++;//17
    printf("id = %d\n", id);
    strcpy(comment, "rapid right turn cont. step");
    data_num = walk02.turnR_cont2      (servo_wav2, leg_prm, arm_prm, body_prm, &step_inf, arm_ang);
    savo_fwrite("17.csv", servo_wav2, data_num);

	step_inf.point_num      = 17;
    id++;//18
    printf("id = %d\n", id);
    strcpy(comment, "rapid right turn first step");
    data_num = walk02.turnR_first2    (servo_wav2, leg_prm, arm_prm, body_prm, &step_inf, arm_ang);
    savo_fwrite("18.csv", servo_wav2, data_num);

	step_inf.point_num      = 17;
    id++;//19
    printf("id = %d\n", id);
    strcpy(comment, "rapid right turn last step");
    data_num = walk02.turnR_last2      (servo_wav2, leg_prm, arm_prm, body_prm, &step_inf, arm_ang);
    savo_fwrite("19.csv", servo_wav2, data_num);
}
