#include <stdio.h>
//#include <conio.h>
//#include <stdlib.h>
//#include <string.h>
//#include <math.h>

#include "pen4_vc.h"
#include "pen4_vc_str.h"
#include "pen4_vc_class.h"

//*******************************************************************************
//ŏ@rUipj
//*******************************************************************************
void walk0_swingarm6(int servo_wav2[WAVE_MAX][12],	struct ARM_PRM arm_prm[2],
				 double start_p, double target_p, int data_num1)
{
int		i, ptr_work, arm_num, org_data, delta_data;
double	a, coo_work[100], dist_work;

	start_p = start_p / 180.0 * PI;
	target_p = target_p / 180.0 * PI;
	//***************************************************************************
	for(arm_num = 0; arm_num < 2; arm_num++)
	{
		ptr_work = 0;
		org_data = angle2servo3(1, start_p, arm_prm[arm_num]);
		//s*********************************************
		dist_work = target_p;
		i = num_line_1Da(coo_work, dist_work, data_num1);
		//T[{f[^@I[o[Cg
		for(i = 0; i < data_num1; i++)
		{
			a = coo_work[i];
			delta_data = angle2servo3(1, a, arm_prm[arm_num]) - org_data;
			servo_wav2[ptr_work][7 + arm_num * 3] =
				servo_wav2[ptr_work][7 + arm_num * 3] + delta_data;
			ptr_work++;
		}
	}
}

//*******************************************************************************
// @rUipj
// servo_wav2		: [Vf[^irƍ͌vZς݁j
// arm_prm			: r̕p[^
// start_p			: Un߂̈ʒu
// target_p			: U
// data_num1		: s
// data_num2		: A
// merge_ptr		: [Vf[^̐ڑ|Cg
//*******************************************************************************
void walk0_swingarm5(int servo_wav2[WAVE_MAX][12],	struct ARM_PRM arm_prm[2],
				 double start_p, double target_p, int data_num1, int data_num2, int merge_ptr)
{
int		i, ptr_work, arm_num, org_data, delta_data, last_data;
double	a, coo_work[100], dist_work;

	start_p = start_p / 180.0 * PI;
	target_p = target_p / 180.0 * PI;
	//***************************************************************************
	for(arm_num = 0; arm_num < 2; arm_num++)
	{
		ptr_work = merge_ptr;
		org_data = angle2servo3(1, start_p, arm_prm[arm_num]);
		//s*********************************************
		dist_work = target_p * 2.0;
		i = num_line_1Da(coo_work, dist_work, data_num1);
		//T[{f[^@I[o[Cg
		for(i = 0; i < data_num1; i++)
		{
			a = - target_p + coo_work[i];
			delta_data = angle2servo3(1, a, arm_prm[arm_num]) - org_data;
			servo_wav2[ptr_work][7 + arm_num * 3] =
				servo_wav2[ptr_work][7 + arm_num * 3] + delta_data;
			ptr_work++;
		}

		//A*********************************************
		dist_work = - target_p * 2.0;
		i = num_line_1Da(coo_work, dist_work, data_num2);
		//T[{f[^@I[o[Cg
		for(i = 0; i < data_num2; i++)
		{
			a =  target_p + coo_work[i];
			delta_data = angle2servo3(1, a, arm_prm[arm_num]) - org_data;
			servo_wav2[ptr_work][7 + arm_num * 3] =
				servo_wav2[ptr_work][7 + arm_num * 3] + delta_data;
			ptr_work++;
		}
		last_data = servo_wav2[ptr_work - 1][7 + arm_num * 3];

		//}[W|Cg܂łŌ̃f[^Ŗ߂***********
		ptr_work = 0;
		//T[{f[^@I[o[Cg
		for(i = 0; i < merge_ptr; i++)
		{
			servo_wav2[ptr_work][7 + arm_num * 3] = last_data;
			ptr_work++;
		}
	}
}

//*******************************************************************************
//Ō@rUipj
//*******************************************************************************
void walk0_swingarm4(int servo_wav2[WAVE_MAX][12],	struct ARM_PRM arm_prm[2],
				 double start_p, double target_p, int data_num1)
{
int		i, ptr_work, arm_num, org_data, delta_data;
double	a, coo_work[100], dist_work;

	start_p = start_p / 180.0 * PI;
	target_p = target_p / 180.0 * PI;
	//***************************************************************************
	for(arm_num = 0; arm_num < 2; arm_num++)
	{
		ptr_work = 0;
		org_data = angle2servo3(1, start_p, arm_prm[arm_num]);
		//s*********************************************
		dist_work = target_p;
		i = num_line_1Da(coo_work, dist_work, data_num1);
		//T[{f[^@I[o[Cg
		for(i = 0; i < data_num1; i++)
		{
			a = - target_p + coo_work[i];
			delta_data = angle2servo3(1, a, arm_prm[arm_num]) - org_data;
			servo_wav2[ptr_work][7 + arm_num * 3] =
				servo_wav2[ptr_work][7 + arm_num * 3] + delta_data;
			ptr_work++;
		}
	}
}

//*******************************************************************************
//Ō@rU
// servo_wav2		: [Vf[^irƍ͌vZς݁j
// arm_prm			: r̕p[^
// start_p			: Un߂̈ʒu
// target_p			: U
// data_num1		: s
// data_num2		: A
// merge_ptr		: [Vf[^̐ڑ|Cg
//*******************************************************************************
void walk0_swingarm3(int servo_wav2[WAVE_MAX][12],	struct ARM_PRM arm_prm[2],
				 double start_p, double target_p, int data_num1, int data_num2, int merge_ptr)
{
int		i, ptr_work, arm_num, org_data, delta_data;
double	a, coo_work[100], dist_work;

	start_p = start_p / 180.0 * PI;
	target_p = target_p / 180.0 * PI;
	//***************************************************************************
	for(arm_num = 0; arm_num < 2; arm_num++)
	{
		ptr_work = merge_ptr;
		org_data = angle2servo3(1, start_p, arm_prm[arm_num]);
		//s*********************************************
		dist_work = target_p * 2.0;
		i = num_line_1Da(coo_work, dist_work, data_num1);
		//T[{f[^@I[o[Cg
		for(i = 0; i < data_num1; i++)
		{
			a = - target_p + coo_work[i];
			delta_data = angle2servo3(1, a, arm_prm[arm_num]) - org_data;
			servo_wav2[ptr_work][7 + arm_num * 3] =
				servo_wav2[ptr_work][7 + arm_num * 3] + delta_data;
			ptr_work++;
		}

		//A*********************************************
		dist_work = - target_p;
		i = num_line_1Da(coo_work, dist_work, data_num2);
		//T[{f[^@I[o[Cg
		for(i = 0; i < data_num2; i++)
		{
			a =  target_p + coo_work[i];
			delta_data = angle2servo3(1, a, arm_prm[arm_num]) - org_data;
			servo_wav2[ptr_work][7 + arm_num * 3] =
				servo_wav2[ptr_work][7 + arm_num * 3] + delta_data;
			ptr_work++;
		}
	}
}

//*******************************************************************************
//͂߁@rU
// servo_wav2		: [Vf[^irƍ͌vZς݁j
// arm_prm			: r̕p[^
// start_p			: Un߂̈ʒu
// target_p			: U
// data_num1		: s
// data_num2		: A
// merge_ptr		: [Vf[^̐ڑ|Cg
//*******************************************************************************
void walk0_swingarm2(int servo_wav2[WAVE_MAX][12],	struct ARM_PRM arm_prm[2],
				 double start_p, double target_p, int data_num1, int data_num2, int merge_ptr)
{
int		i, ptr_work, arm_num, org_data, delta_data;
double	a, coo_work[100], dist_work;

	start_p = start_p / 180.0 * PI;
	target_p = target_p / 180.0 * PI;
	//***************************************************************************
	for(arm_num = 0; arm_num < 2; arm_num++)
	{
		ptr_work = merge_ptr;
		org_data = angle2servo3(1, start_p, arm_prm[arm_num]);
		//s*********************************************
		dist_work = target_p;
		i = num_line_1Da(coo_work, dist_work, data_num1);
		//T[{f[^@I[o[Cg
		for(i = 0; i < data_num1; i++)
		{
			a = start_p + coo_work[i];
			delta_data = angle2servo3(1, a, arm_prm[arm_num]) - org_data;
			servo_wav2[ptr_work][7 + arm_num * 3] =
				servo_wav2[ptr_work][7 + arm_num * 3] + delta_data;
			ptr_work++;
		}

		//A*********************************************
		dist_work = - target_p * 2.0;
		i = num_line_1Da(coo_work, dist_work, data_num2);
		//T[{f[^@I[o[Cg
		for(i = 0; i < data_num2; i++)
		{
			a =  target_p + coo_work[i];
			delta_data = angle2servo3(1, a, arm_prm[arm_num]) - org_data;
			servo_wav2[ptr_work][7 + arm_num * 7] =
				servo_wav2[ptr_work][7 + arm_num * 3] + delta_data;
			ptr_work++;
		}
	}
}

//*******************************************************************************
// @rU
// servo_wav2		: [Vf[^irƍ͌vZς݁j
// arm_prm			: r̕p[^
// start_p			: Un߂̈ʒu
// target_p			: U
// data_num1		: s
// data_num2		: A
// merge_ptr		: [Vf[^̐ڑ|Cg
//*******************************************************************************
void walk0_swingarm1(int servo_wav2[WAVE_MAX][12],	struct ARM_PRM arm_prm[2],
				 double start_p, double target_p, int data_num1, int data_num2, int merge_ptr)
{
int		i, ptr_work, arm_num, org_data, delta_data;
double	a, coo_work[100], dist_work;

	start_p = start_p / 180.0 * PI;
	target_p = target_p / 180.0 * PI;
	//***************************************************************************
	for(arm_num = 0; arm_num < 2; arm_num++)
	{
		ptr_work = merge_ptr;
		org_data = angle2servo3(1, start_p, arm_prm[arm_num]);
		//s*********************************************
		dist_work = target_p * 2.0;
		i = num_line_1Da(coo_work, dist_work, data_num1);
		//T[{f[^@I[o[Cg
		for(i = 0; i < data_num1; i++)
		{
			a = - target_p + coo_work[i];
			delta_data = angle2servo3(1, a, arm_prm[arm_num]) - org_data;
			servo_wav2[ptr_work][7 + arm_num * 3] =
				servo_wav2[ptr_work][7 + arm_num * 3] + delta_data;
			ptr_work++;
		}

		//A*********************************************
		dist_work = - target_p * 2.0;
		i = num_line_1Da(coo_work, dist_work, data_num2);
		//T[{f[^@I[o[Cg
		for(i = 0; i < data_num2; i++)
		{
			a =  target_p + coo_work[i];
			delta_data = angle2servo3(1, a, arm_prm[arm_num]) - org_data;
			servo_wav2[ptr_work][7 + arm_num * 3] =
				servo_wav2[ptr_work][7 + arm_num * 3] + delta_data;
			ptr_work++;
		}
	}
}
