#include "pen4_vc.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "pen4_vc_str.h"


//**********************************************************
//@O_t@Cɏo
//@
//@@filename0F֐߃p[^t@C̃t@C
//@@coo_wav1FO_
//@@numFO_̃f[^
//@߂l
//@@@OF
//@@|PFs
//**********************************************************
int coo_fwrite(char filename0[32], double coo_wav1[2][WAVE_MAX][3], int num)
{
int     i,j,k;

FILE    *fpo;
errno_t err;

	if ((err = fopen_s(&fpo, filename0 , "wt")) == 0)
	{
		for(i = 0; i < num; i++)
	    {
		   for(j = 0; j < 2; j++)
		   {
				for(k = 0; k < 3; k++)
				{
					fprintf(fpo, "%f, ", coo_wav1[j][i][k]);
				}
			}
			fprintf(fpo, "\n");
		}
		fclose(fpo);
	}
	else
	{
		printf("G[I_Wt@C܂ł\n");
		return(-1);
	}
	return(0);
}

//**********************************************************
//**********************************************************
int savo_fwrite(char filename0[32], int servo_data[WAVE_MAX][12], int num)
{
    int     i,j;

    if(num >= 64) printf("Worning : Motion data element number exceed the limit 64.\n");

    FILE *fpo2 = fopen(filename0 , "wt");
    if (fpo2 != NULL) {
        for(j = 0; j < num; j++) {
            for(i = 0; i < 11; i++) {
                fprintf(fpo2, "%d,", servo_data[j][i]);
            }
            fprintf(fpo2, "%d,", servo_data[j][i]);
            fprintf(fpo2, "\n");
        }
        fclose(fpo2);
    } else {
        printf("Error! cannot create the servo data file.(savo_fwrite)\n");
        return(-1);
    }
    return(0);
}
//**********************************************************
//@[Vf[^t@Cɏ
//@߂l|P܂Ńf[^Ă
//@
//@@filename0F[Vf[^̃t@C
//@@qF[Vf[^
//@@numF[Vf[^̃f[^
//@@modeF݃[h
//@@@@@@FeLXg[hŒǉ
//@@@@ȊOFeLXg[hŏ㏑
//@@idF[Vf[^̂ԍ
//@@commentF[Vf[^̃Rg
//@߂l
//@@@OF
//@@|PFs
//**********************************************************
int savo_fwrite2(char filename0[32], int q[WAVE_MAX][12]
				 , int num, char mode, int id, char comment[256])
{
int     i,j;
char	mode2[3];

FILE    *fpo2;
errno_t err;

	if (mode == 'a') strcpy_s(mode2, 3, "at");
	else strcpy_s(mode2, 3, "wt");

	if(num >= 64) printf("xF[Vf[^̃|CgUS𒴂Ă܂B\n");

	if ((err = fopen_s(&fpo2, filename0 , mode2)) == 0)
	{
		fprintf(fpo2, "id, %d , %s\n", id, comment);
		fprintf(fpo2, "data_num, %d\n", num);
		for(j = 0; j < num; j++)
		{
			for(i = 0; i < 11; i++)
			{
				fprintf(fpo2, "%d, ", q[j][i]);
			}
			fprintf(fpo2, "%d, ", q[j][i]);
			fprintf(fpo2, "\n");
		}
		fclose(fpo2);
	}
	else
	{
		printf("G[IT[{t@C܂ł\n");
		return(-1);
	}
	return(0);
}

//**********************************************************
//hcwŃ[Vf[^t@Cǂݍ
//**********************************************************
int savo_fread2(char filename[32], int servo_data[WAVE_MAX][12], int id_target)
{
int		i, j, k, id, data_num;
char    buff[256], fields[32][64];
FILE	*fp;

	if ((fp = fopen(filename , "rt")) == NULL)
	{
		printf("Motion data file open error!(savo_fread2)\n");
		return(-1);
	}

	while (fgets(buff, 256, fp) != NULL)
	{
	   //f[^t@Cǂ***********************
	   k = devide_into_field(buff, "," , fields);
	   if(strcmp(fields[0], "id") != 0)
	   {
			printf("File format error! Invalid ID field.(savo_fread2)\n");
			return(-1);
	   }
	   else
	   {
		   id = atoi(fields[1]);
		   printf("%s", buff);
	   }

		fgets(buff, 256, fp);
		k = devide_into_field(buff, "," , fields);
		if(strcmp(fields[0], "data_num") != 0)
		{
			printf("File format error! Invalid data_num field.(savo_fread2)\n");
			return(-1);
		}
		else
			data_num = atoi(fields[1]);

		for(i = 0; i < data_num; i++)
		{
			fgets(buff, 256, fp);
			//w肳ꂽhĉ݈ɃZbgB͓ǂݔ΂
			if(id_target == id){
				k = devide_into_field(buff, "," , fields);
				for(j = 0; j < 12; j++)
					servo_data[i][j] = atoi(fields[j]);
			}
		}
		//ړĨf[^ꂽƂŋA
		if(id_target == id) break;
   }
   fclose(fp);
   return(data_num);
}
