#include <stdio.h>
#include <math.h>
#include "pen4_vc.h"


/************************************************************************/
/*   Q~̌_̍W߂                                           */
/*   coo[2][2]...Q~̒SW, ʂ̌_W֕Ԃ@       */
/*   r[2]     ...Q~̔a                                             */
/************************************************************************/
int Calc_2D::crcir(double coo[2][2],double r[2])
{
int		ii,jj;
double   x0,y0,x1,y1,x5,y5;
double   a,aa,b,e,f,h,i,l,l2,m,o,p;
double	a1,d;
double   vr0[2],vx[2],vy[2],r0,r1,r2,r3,cosq1,sinq1;
double   offset,offset1;


	//Q~XW̗O
	if(coo[0][0] == coo[1][0])
	{
		x0 = coo[0][0];
		y0 = coo[0][1];
		x1 = coo[1][0];
		y1 = coo[1][1];

		d = coo[1][1] - coo[0][1];
		a1 = ((r[0] * r[0]) - (r[1] * r[1]) + (d * d)) / (2 * d);
		aa = (r[0] * r[0]) - (a1 * a1);
		if(aa < 0.0)
		{
			//printf("Q~̌_܂܂(crcir)\n");
			return(-1);
		}
		b = sqrt(aa);

		coo[0][0] = x0 - b;
		coo[0][1] = y0 + a1;

		coo[1][0] = x0 + b;
		coo[1][1] = y0 + a1;

		return(0);
	}

	offset1 = 0.0;
	for(ii = 0; ii < 2; ii++)
	{
		for(jj = 0; jj < 2; jj++)
		{
			if(coo[ii][jj] < offset1) offset1 = coo[ii][jj];
		}
	}

	offset = (r[0] + r[1]) * 2 - offset1;

	h = coo[0][0] + offset;
	i = coo[0][1] + offset;
	e = coo[1][0] + offset;
	f = coo[1][1] + offset;
	r1 = r[0];
	r2 = r[1];
	r3 = r1 + r2;

	vr0[0] = e - h;
	vr0[1] = f - i;
	r0 = sqrt( vr0[0] * vr0[0] + vr0[1] * vr0[1]);

	/*܂_쐬\`FbNA_ȂG[*/
	if ( r0 > r3)
	{
		return(-1);
	}

	cosq1 = (r0 * r0 + r1 * r1 - r2 * r2) / ( 2 * r0 * r1 );
	sinq1 = sqrt(1 - cosq1 * cosq1);

	vx[0] = vr0[0] / r0;
	vx[1] = vr0[1] / r0;
	vy[0] = -vx[1];
	vy[1] = vx[0];

	l = r1 * cosq1 * vx[0] + r1 * sinq1 * vy[0] + h;
	m = r1 * cosq1 * vx[1] + r1 * sinq1 * vy[1] + i;

	coo[0][0] = l - offset;
	coo[0][1] = m - offset;

	a = vx[1] / vx[0];
	b = vy[1] / vy[0];
	x5 = (a * h - b * l + m - i) / (a - b);
	y5 = a * (x5 - h) + i;
	a = x5 - l;
	b = y5 - m;
	l2 = sqrt( a * a + b * b);
	o = - vy[0] * 2 * l2 + l;
	p = - vy[1] * 2 * l2 + m;
	coo[1][0] = o - offset;
	coo[1][1] = p - offset;

return(0);
}
/*******************************************************************/
/**  Cӂ̂Q_Ԃ̋߂                                   **/
/**  coo[0][0] : x1  coo[0][1] : y1                               **/
/**  coo[1][0] : x2  coo[1][1] : y2                               **/
/*******************************************************************/
double Calc_2D::dist_2points(double coo[2][2])
{
double distance;
	distance = sqrt(pow((coo[0][0]-coo[1][0]),2) + pow((coo[0][1]-coo[1][1]),2));
	return(distance);
}

/*******************************************************************/
/**  ]̂PϊŔCӂ̓_𒆐SɂĔCӂ̓_]       **/
/**  coo[0][0] : x1  coo[0][1] : y1                               **/
/**  coo[1][0] : x2  coo[1][1] : y2                               **/
/**  canter_x, y : ]ϊ̒S@                               **/
/**  direction   : ]p@@@@@@                             **/
/**  data_num    : ]f[^                               **/
/**  @@cooɁAQz̐擪w|C^n              **/
/*******************************************************************/
void Calc_2D::rotate_1D(double coo[WAVE_MAX][2], double center_x,
			double center_y, double direction, int data_num)
{
int     i;
double   x,y;

/* 󂯎WQ]̒S_ɗ悤ɕsړ */
   for (i = 0; i < data_num; i++)
   {
     coo[i][0] = coo[i][0] - center_x;
     coo[i][1] = coo[i][1] - center_y;
   }

/* _𒆐SƂĉ]̈ꎟϊ */
   for (i = 0; i < data_num; i++)
   {
     x = coo[i][0];
     y = coo[i][1];
     coo[i][0] = x * cos (direction) - y * sin (direction);
     coo[i][1] = x * sin (direction) + y * cos (direction);
   }

/* 󂯎WQ]̒S̈ʒuɗ悤ɕsړ߂ */
   for (i = 0; i < data_num; i++)
   {
     coo[i][0] = coo[i][0] + center_x;
     coo[i][1] = coo[i][1] + center_y;
   }
}

/******************************************************************/
/**  אڂxNg݂̈̊pxvZ          **/
/**  coo : vZxNg̍W@@@@@@@@@@          **/
/**  xNgcoo[0][x]->coo[1][x]->coo[2][x]̏ɐڑ̂ **/
/**  ۂɂ coo[1][x] ł̊px߂B@@@@           **/
/******************************************************************/
double Calc_2D::vector_dir_f(double coo[3][2])
{
double   coof[2][2],q1,q3;

	/* make vector BC*/
	coof[0][0] = coo[2][0] - coo[1][0];
	coof[0][1] = coo[2][1] - coo[1][1];

	/* make vector AB*/
	coof[1][0] = coo[1][0] - coo[0][0];
	coof[1][1] = coo[1][1] - coo[0][1];


	/* cluculate Q1 */
	q1 = atan2(coof[1][1], coof[1][0]);

	/*************************************/
	/* adjst Q2 to Q3 */
	rotate_1D(coof, 0.0, 0.0, -q1, 1);

	/*************************************/
	/* cluculate Q3 */
	q3 = atan2(coof[0][1], coof[0][0]);

return(q3);
}

/*******************************************************************/
/**  Cӂ̂Q_Ԃ̋߂                                   **/
/**  coo[0][0] : x1  coo[0][1] : y1  coo[0][2] : z1               **/
/**  coo[1][0] : x2  coo[1][1] : y2  coo[1][2] : z1               **/
/*******************************************************************/
double Calc_3D::dist_2points3D(double coo[2][3])
{
double distance;
	distance = sqrt(pow((coo[0][0]-coo[1][0]),2) + pow((coo[0][1]-coo[1][1]),2) + pow((coo[0][2]-coo[1][2]),2));
	return(distance);
}
