#include <stdio.h>
#include <string.h>
#include <math.h>
#include "pen4_vc.h"
#include "pen4_vc_str.h"
#include "pen4_vc_class.h"

//**********************************************************
//@s[Vf[^쐬ii^j
//@
//@@servo_wav2F[Vf[^
//@@leg_prmFrp\
//@@arm_prmFrp\
//@@body_prmF̗p\
//@@step_infFs[Vp\
//@@arm_angFr֐߂̌Œpx
//@߂l
//@@[Vf[^
//**********************************************************
int Walk01::back_cont(int servo_wav2[WAVE_MAX][12], struct LEG_PRM leg_prm[2],  struct ARM_PRM arm_prm[2],
			struct BODY_PRM body_prm, struct STEP_INF *step_inf, double arm_ang[2][3])
{
int		i, j, k, data_num, data_num2, joint_point;

double	a, q, r, dist, cx, cz, l1, l2, l3, v0;
double	coo0[WAVE_MAX][2];
struct	NUMBER_LINE number_line;

double	coo_wav1[2][WAVE_MAX][3];
double	angle2[WAVE_MAX][2][2];


	//O_ϐ̏
	for(i = 0; i < step_inf->point_num * 2; i++)
		for(k = 0; k < 2; k++) coo_wav1[k][i][1] = 0.0;

	//̃X^[gʒuij
	coo_wav1[1][0][0] = step_inf->offset[1][0] - step_inf->travel / 2.0;
	coo_wav1[1][0][1] = step_inf->offset[1][1];
	coo_wav1[1][0][2] = step_inf->offset[1][2];

	//******************************************************************
	//O֑
	dist = step_inf->travel;
	v0 = step_inf->travel / (double)(step_inf->point_num + step_inf->overlap_num);

	a = 0;
	for(i = 0; i < step_inf->point_num + step_inf->overlap_num; i++)
	{
		coo_wav1[1][i][0] = coo_wav1[1][0][0] + a;
		coo_wav1[1][i][2] = coo_wav1[1][0][2];
		a = a + v0;
	}

	data_num = i;
	
	//ړoHvZ
	//グ镔i1/2~)
	l1 = PI * step_inf->v_diff / 2.0;
	//𑗂镔
	l2 = step_inf->travel;
	//낷(1/2~)
	l3 = PI * step_inf->v_diff / 2.0;

	//ړ̍v
	a = l1 + l2 + l3;
	//xグĉ҂̋
	dist = a - v0 * (step_inf->point_num - step_inf->overlap_num);

	number_line.length = dist;
	number_line.point_num = step_inf->point_num - step_inf->overlap_num;

	num_line1b(coo0, number_line);

	//OɓĂ͂߂*********************
	coo0[0][0] = 0.0;
	//̊Jn_ƏI_̑x킹
	for(i = 1; i < number_line.point_num; i++)
	{
		coo0[i][0] = coo0[i - 1][0] + coo0[i][1] + v0;
	}

	//グ镔i1/2~)
	r = step_inf->v_diff / 2.0;
	cx = step_inf->offset[1][0] + step_inf->travel / 2.0;
	cz = step_inf->offset[1][2] + step_inf->v_diff / 2.0;
	data_num2 = 0;
	while(coo0[data_num2][0] < l1)
	{
		q = coo0[data_num2][0] / r;//~ʂ̒Sp
		coo_wav1[1][data_num][0] = cx + r * sin(q);// X
		coo_wav1[1][data_num][2] = cz - r * cos(q);// Z
		data_num++;
		data_num2++;
	}

	//グ
	while(coo0[data_num2][0] < l1 + l2)
	{
		coo_wav1[1][data_num][0] =-(coo0[data_num2][0] - l1) + (step_inf->offset[1][0] + step_inf->travel / 2.0);// X
		coo_wav1[1][data_num][2] = step_inf->offset[0][2] + step_inf->v_diff;// Z
		data_num++;
		data_num2++;
	}

	//镔i1/2~)
	cx = step_inf->offset[1][0] - step_inf->travel / 2.0;
	cz = step_inf->offset[1][2] + step_inf->v_diff / 2.0;
	while(data_num < step_inf->point_num * 2)
	{
		q = (coo0[data_num2][0] - (l1 + l2)) / r;//~ʂ̒Sp
		coo_wav1[1][data_num][0] = cx - r * sin(q);// X
		coo_wav1[1][data_num][2] = cz + r * cos(q);// Z
		data_num++;
		data_num2++;
	}

	//******************************************************************
	//Erf[^쐬ir̃f[^ʑςăRs[j
	j = 0;
	for(i = data_num / 2; i < data_num; i++)
	{
		coo_wav1[0][j][0] = coo_wav1[1][i][0];// X
		coo_wav1[0][j][2] = coo_wav1[1][i][2];// Z
		j++;
	}
	for(i = 0; i < data_num / 2; i++)
	{
		coo_wav1[0][j][0] = coo_wav1[1][i][0];// X
		coo_wav1[0][j][2] = coo_wav1[1][i][2];// Z
		j++;
	}

	//O_t@Cɏoi`FbNpj
	j = coo_fwrite("pen4.csv", coo_wav1, data_num);

	//O_qbT[{o̓f[^i[Vf[^jɕϊ
	i = orbit2servo_wav1(coo_wav1, angle2, &servo_wav2[0], data_num, leg_prm);

	//**************************************************************
	//̃[p_f[^쐬
	dist = step_inf->swingR - step_inf->swingL;
	number_line.length = dist;
	number_line.point_num = step_inf->point_num;
	num_line1b(coo0, number_line);

	//㔼gUf[^}
	joint_point = step_inf->point_num / 2 + step_inf->overlap_num;
	step_inf->swing_connect = coo0[joint_point][0] + step_inf->swingL;
	step_inf->connect_speed = coo0[joint_point][1];
	j = 0;
	for(i = joint_point; i < number_line.point_num; i++)
	{
		a = (coo0[i][0] + step_inf->swingL) / 180.0 * PI;
		servo_wav2[j][4] = angle2servo2(0, a, body_prm);
		k = servo_wav2[j][4];
		j++;
	}
	for(i = number_line.point_num - 1; i >= 0; i--)
	{
		a = (coo0[i][0] + step_inf->swingL) / 180.0 * PI;
		servo_wav2[j][4] = angle2servo2(0, a, body_prm);
		k = servo_wav2[j][4];
		j++;
	}
	for(i = 0; i < joint_point; i++)
	{
		a = (coo0[i][0] + step_inf->swingL) / 180.0 * PI;
		servo_wav2[j][4] = angle2servo2(0, a, body_prm);
		k = servo_wav2[j][4];
		j++;
	}

	//r̃f[^}
	//̃sb`f[^͒Ƃ
	for(i = 0; i < step_inf->point_num * 2 + 1; i++)
	{
		servo_wav2[i][5] = angle2servo2(1, 0.0, body_prm);
		k = 0;
		for(j = 6; j < 9; j++)
		{
			servo_wav2[i][j] = angle2servo3(k, arm_ang[0][k], arm_prm[0]);
			k++;
		}
		k = 0;
		for(j = 9; j < 12; j++)
		{
			servo_wav2[i][j] = angle2servo3(k, arm_ang[1][k], arm_prm[1]);
			k++;
		}
	}
	//*********************************************************************************
	return(data_num);
}