#include <stdio.h>
#include <string.h>
#include <math.h>
#include "pen4_vc.h"
#include "pen4_vc_str.h"
#include "pen4_vc_class.h"

//**********************************************************
//@s[Vf[^쐬iOi^Ō̈j
//@
//@@servo_wav2F[Vf[^
//@@leg_prmFrp\
//@@arm_prmFrp\
//@@body_prmF̗p\
//@@step_infFs[Vp\
//@@arm_angFr֐߂̌Œpx
//@߂l
//@@[Vf[^
//**********************************************************
int Walk01::for_last(int servo_wav2[WAVE_MAX][12], struct LEG_PRM leg_prm[2], struct ARM_PRM arm_prm[2],
			struct BODY_PRM body_prm, struct STEP_INF *step_inf,double arm_ang[2][3])
{
int		i, j, k, data_num, joint_point;

double	a, a0, s0, q, r, dist, dist0, dist1, cx, cz, l1, l2, l3, v0, v1, dist_overlap;
double	coo0[WAVE_MAX][2];
struct	NUMBER_LINE number_line;

double	coo_wav1[2][WAVE_MAX][3];
double	angle2[WAVE_MAX][2][2];


	//O_ϐ̏
	for(i = 0; i < step_inf->point_num * 2; i++)
		for(k = 0; k < 2; k++) coo_wav1[k][i][1] = 0.0;

	//ẼX^[gʒuiOj
	coo_wav1[0][0][0] = step_inf->offset[0][0] + step_inf->travel / 2.0;
	coo_wav1[0][0][1] = step_inf->offset[0][1];
	coo_wav1[0][0][2] = step_inf->offset[0][2];

	dist_overlap = step_inf->travel / (double)(step_inf->point_num + step_inf->overlap_num);
	//̃X^[gʒuij
	coo_wav1[1][0][0] = step_inf->offset[1][0] - step_inf->travel / 2.0 + dist_overlap;
	coo_wav1[1][0][1] = step_inf->offset[1][1];
	coo_wav1[1][0][2] = step_inf->offset[1][2];

	//******************************************************************
	//Ȋxifor_contɓ)
	v0 = step_inf->travel / (double)(step_inf->point_num + step_inf->overlap_num);
	//E
	//ړoHvZ
	dist = step_inf->travel / 2.0;

	//ōŏIx܂ŉ̈ړ
	dist0 = 0.5 * step_inf->point_num * v0;

	//x̂߂ɏdˍ킹ړ
	dist1 = dist - dist0;

	number_line.length = dist1;
	number_line.point_num = step_inf->point_num;

	num_line1b(coo0, number_line);

	a0 = v0 / number_line.point_num;
	v1 = v0;
	s0 = v1;
	i = 1;
	while(i < step_inf->point_num)
	{
		coo_wav1[0][i][0] = coo_wav1[0][0][0] - coo0[i][0] - s0;// X
		coo_wav1[0][i][2] = coo_wav1[0][0][2];// Z
		v1 = v1 - a0;
		s0 = s0 + v1;
		i++;
	}

	//******************************************************************
	//O
	//ړoHvZ
	//镔i1/4~)
	l1 = 0.25 * PI * 2.0 * step_inf->v_diff;
	//𑗂镔
	l2 = step_inf->travel / 2.0 - step_inf->v_diff - dist_overlap;
	//グ镔(1/2~)
	l3 = PI * step_inf->v_diff / 2.0;

	dist = l1 + l2 + l3;

	//ōŏIx܂ŉ̈ړ
	dist0 = 0.5 * step_inf->point_num * v0;

	//x̂߂ɏdˍ킹ړ
	dist1 = dist - dist0;

	number_line.length = dist1;
	number_line.point_num = step_inf->point_num;

	num_line1b(coo0, number_line);

	//グ镔i1/2~)
	i = 1;
	r = step_inf->v_diff / 2.0;
	cx = step_inf->offset[1][0] - step_inf->travel / 2.0 + dist_overlap;
	cz = step_inf->offset[1][2] + step_inf->v_diff / 2.0;
	a0 = v0 / number_line.point_num;
	v1 = v0;
	s0 = v1;
	while(coo0[i][0] + s0 < l3)
	{
		q = (coo0[i][0] + s0)/ r;//~ʂ̒Sp
		coo_wav1[1][i][0] = cx - r * sin(q);// X
		coo_wav1[1][i][2] = cz - r * cos(q);// Z
		v1 = v1 - a0;
		s0 = s0 + v1;
		i++;
	}

	//グ
	while(coo0[i][0] + s0 < l3 + l2)
	{
		coo_wav1[1][i][0] = cx + (coo0[i][0] + s0 - l3);// X
		coo_wav1[1][i][2] = cz + step_inf->v_diff / 2.0;// Z
		v1 = v1 - a0;
		s0 = s0 + v1;
		i++;
	}

	//镔i1/4~)
	r = step_inf->v_diff;
	cx = step_inf->offset[1][0] - step_inf->v_diff;
	cz = step_inf->offset[1][2];
	while(i < step_inf->point_num)
	{
		q = (coo0[i][0] + s0 - (l3 + l2)) / r;//~ʂ̒Sp
		coo_wav1[1][i][0] = cx + r * sin(q);// X
		coo_wav1[1][i][2] = cz + r * cos(q);// Z
		//vZ덷ۂ߂
		if(coo_wav1[1][i][2] <= coo_wav1[1][0][2]){
			coo_wav1[1][i][2] = coo_wav1[1][0][2];
		}
		v1 = v1 - a0;
		s0 = s0 + v1;
		i++;
	}

	//O_t@Cɏoi`FbNpj
	j = coo_fwrite("pen4.csv", coo_wav1, step_inf->point_num);

	//O_qbT[{o̓f[^i[Vf[^jɕϊ
	i = orbit2servo_wav1(coo_wav1, angle2, &servo_wav2[0], step_inf->point_num, leg_prm);
	//*********************************************************************************
	//̃[p_f[^쐬
	dist = step_inf->swingL - step_inf->swingR;
	number_line.length = dist;
	number_line.point_num = step_inf->point_num;
	num_line1b(coo0, number_line);

	//㔼gUf[^}
	joint_point = step_inf->point_num / 2 + step_inf->overlap_num;
	step_inf->swing_connect = coo0[joint_point][0] + step_inf->swingR;
	step_inf->connect_speed = coo0[joint_point][1];
	j = 0;
	for(i = joint_point; i < number_line.point_num; i++)
	{
		a = (coo0[i][0] + step_inf->swingR) / 180.0 * PI;
		servo_wav2[j][4] = angle2servo2(0, a, body_prm);
		k = servo_wav2[j][4];
		j++;
	}
	data_num = j;
	//*********************************************************************************
	//̃[p_f[^쐬
	dist = - step_inf->swingL;
	number_line.length = dist;
	number_line.point_num = step_inf->point_num - data_num + 1;
	num_line1b(coo0, number_line);

	//㔼gUf[^}
	j = 0;
	for(i = data_num; i < step_inf->point_num; i++)
	{
		a = (step_inf->swingL + coo0[j][0])  / 180.0 * PI;
		servo_wav2[i][4] = angle2servo2(0, a, body_prm);
		j++;
	}

	//r̃f[^}
	//̃sb`f[^͒Ƃ
	for(i = 0; i < step_inf->point_num; i++)
	{
		servo_wav2[i][5] = angle2servo2(1, 0.0, body_prm);
		k = 0;
		for(j = 6; j < 9; j++)
		{
			servo_wav2[i][j] = angle2servo3(k, arm_ang[0][k], arm_prm[0]);
			k++;
		}
		k = 0;
		for(j = 9; j < 12; j++)
		{
			servo_wav2[i][j] = angle2servo3(k, arm_ang[1][k], arm_prm[1]);
			k++;
		}
	}

	return(step_inf->point_num);
}


//**********************************************************
//@s[Vf[^쐬iOi^ŏ̈j
//@
//@@servo_wav2F[Vf[^
//@@leg_prmFrp\
//@@arm_prmFrp\
//@@body_prmF̗p\
//@@step_infFs[Vp\
//@@arm_angFr֐߂̌Œpx
//@߂l
//@@[Vf[^
//**********************************************************
int Walk01::for_first(int servo_wav2[WAVE_MAX][12], struct LEG_PRM leg_prm[2],  struct ARM_PRM arm_prm[2],
			struct BODY_PRM body_prm, struct STEP_INF *step_inf,double arm_ang[2][3])
{
int		i, j, k, data_num, data_num2;

double	a, a0, s0, q, r, dist, dist0, dist1, cx, cz, l1, l2, l3, v0, v1;
double	coo0[WAVE_MAX][2];
struct	NUMBER_LINE number_line;

double	coo_wav1[2][WAVE_MAX][3];
double	angle2[WAVE_MAX][2][2];

	//O_ϐ̏
	for(i = 0; i < step_inf->point_num * 2; i++)
		for(k = 0; k < 2; k++) coo_wav1[k][i][1] = 0.0;

	//ẼX^[gʒu
	coo_wav1[0][0][0] = step_inf->offset[0][0];
	coo_wav1[0][0][1] = step_inf->offset[0][1];
	coo_wav1[0][0][2] = step_inf->offset[0][2];

	//̃X^[gʒu
	coo_wav1[1][0][0] = step_inf->offset[1][0];
	coo_wav1[1][0][1] = step_inf->offset[1][1];
	coo_wav1[1][0][2] = step_inf->offset[1][2];

	//******************************************************************
	//Ȋxifor_contɓ)
	v0 = step_inf->travel / (double)(step_inf->point_num + step_inf->overlap_num);
	//EO
	//ړoHvZ
	//グ镔i1/4~)
	l1 = 0.25 * PI * 2.0 * step_inf->v_diff;
	//𑗂镔
	l2 = step_inf->travel / 2.0 - l1;
	//낷(1/2~)
	l3 = PI * step_inf->v_diff / 2.0;

	//ړ̍v
	dist = l1 + l2 + l3;

	//ōŏIx܂ŉ̈ړ
	dist0 = 0.5 * step_inf->point_num * v0;

	//x̂߂ɏdˍ킹ړ
	dist1 = dist - dist0;

	number_line.length = dist1;
	number_line.point_num = step_inf->point_num;

	num_line1b(coo0, number_line);

	//グ镔i1/4~)
	i = 1;
	r = step_inf->v_diff;
	cx = coo_wav1[0][0][0] + step_inf->v_diff;
	cz = coo_wav1[0][0][2] + 0.0;
	a0 = v0 / number_line.point_num;
	v1 = a0;
	s0 = v1;
	q = 0;
	while(coo0[i][0] + s0 < l1)
	{
		q = (coo0[i][0] + s0) / r;//~ʂ̒Sp
		coo_wav1[0][i][0] = cx - r * cos(q);// X
		coo_wav1[0][i][2] = cz + r * sin(q);// Z
		v1 = v1 + a0;
		s0 = s0 + v1;
		i++;
	}

	//グ
	while(coo0[i][0] + s0 < l1 + l2)
	{
		coo_wav1[0][i][0] = cx + (coo0[i][0] + s0 - l1);// X
		coo_wav1[0][i][2] = cz + step_inf->v_diff;// Z
		v1 = v1 + a0;
		s0 = s0 + v1;
		i++;
	}

	//镔
	r = step_inf->v_diff / 2.0;
	cx = coo_wav1[0][0][0] + step_inf->travel / 2.0;
	cz = coo_wav1[0][0][2] + step_inf->v_diff / 2.0;
	while(i < step_inf->point_num)
	{
		q = (coo0[i][0] + s0 - (l1 + l2)) / r;//~ʂ̒Sp
		coo_wav1[0][i][0] = cx + r * sin(q);// X
		coo_wav1[0][i][2] = cz + r * cos(q);// Z
		v1 = v1 + a0;
		s0 = s0 + v1;
		i++;
	}

	//******************************************************************
	//
	//ړoHvZ
	//I[o[bv̕ϐ
	a = step_inf->travel / (double)(step_inf->point_num + step_inf->overlap_num);
	dist = step_inf->travel / 2.0 - a; 

	//x̂߂ɏdˍ킹ړ
	dist1 = dist - dist0;

	number_line.length = dist1;
	number_line.point_num = step_inf->point_num;

	num_line1b(coo0, number_line);

	//֑镔
	i = 1;
	cx = coo_wav1[1][0][0];
	cz = coo_wav1[1][0][2];
	v1 = a0;
	s0 = v1;
	while(i < step_inf->point_num)
	{
		coo_wav1[1][i][0] = cx - coo0[i][0] - s0;// X
		coo_wav1[1][i][2] = cz;// Z
		v1 = v1 + a0;
		s0 = s0 + v1;
		i++;
	}


	//O_t@Cɏoi`FbNpj
	j = coo_fwrite("pen4.csv", coo_wav1, step_inf->point_num);

	//O_qbT[{o̓f[^i[Vf[^jɕϊ
	i = orbit2servo_wav1(coo_wav1, angle2, &servo_wav2[0], step_inf->point_num, leg_prm);

	//*********************************************************************************
	//̃[p_f[^쐬
	//ݏoOɏ㔼gX
	//납猩Ĕv肪
	dist = step_inf->swingR;
	number_line.length = dist;
	number_line.point_num = step_inf->point_num / 2;//2013/4/7 ύXB̐UsŉEオĂȂ΍
	num_line1b(coo0, number_line);

	//T[{f[^ɃVtgBi㔼g̐Uoj
	k = step_inf->point_num + number_line.point_num - 1;
	for(i = step_inf->point_num - 1; i >= 0; i--)
	{
		for(j = 0; j < 4; j++)
		{
			servo_wav2[k][j] = servo_wav2[i][j];
		}
		k--;
	}

	//㔼gUĂԂ̋r̃f[^AsJnʒũf[^Ŗ߂
	for(i = 0; i < number_line.point_num; i++)
	{
		for(j = 0; j < 4; j++)
		{
			servo_wav2[i][j] = servo_wav2[0][j];
		}
	}

	//㔼gUf[^}
	for(i = 0; i < number_line.point_num; i++)
	{
		a = coo0[i][0] / 180.0 * PI;
		servo_wav2[i][4] = angle2servo2(0, a, body_prm);
	}
	data_num  = number_line.point_num;
	data_num2 = step_inf->point_num + number_line.point_num;

	//*********************************************************************************
	//Ȋxifor_contɓ)
	v0 = step_inf->connect_speed;

	dist = step_inf->swing_connect - step_inf->swingR - v0 * 2.0;

	//ōŏIx܂ŉ̈ړ
	dist0 = 0.5 * step_inf->point_num * v0;

	//x̂߂ɏdˍ킹ړ
	dist1 = dist - dist0;

	number_line.length = dist1;
	number_line.point_num = step_inf->point_num;

	num_line1b(coo0, number_line);

	//㔼gUf[^}
	j = 0;
	a0 = v0 / number_line.point_num;
	v1 = a0;
	s0 = v1;
	for(i = data_num; i < data_num2; i++)
	{
		a = (step_inf->swingR + coo0[j][0] + s0)  / 180.0 * PI;
		servo_wav2[i][4] = angle2servo2(0, a, body_prm);
		v1 = v1 + a0;
		s0 = s0 + v1;
		j++;
	}

	//r̃f[^}
	//̃sb`f[^͒Ƃ
	for(i = 0; i < data_num2; i++)
	{
		servo_wav2[i][5] = angle2servo2(1, 0.0, body_prm);
		k = 0;
		for(j = 6; j < 9; j++)
		{
			servo_wav2[i][j] = angle2servo3(k, arm_ang[0][k], arm_prm[0]);
			k++;
		}
		k = 0;
		for(j = 9; j < 12; j++)
		{
			servo_wav2[i][j] = angle2servo3(k, arm_ang[1][k], arm_prm[1]);
			k++;
		}
	}

	return(data_num2);
}
