#include <stdio.h>
#include <string.h>
#include <math.h>
#include "pen4_vc.h"
#include "pen4_vc_str.h"
#include "pen4_vc_class.h"

//**********************************************************
//@s[Vf[^쐬iMn^ŏ̈j
//@
//@@servo_wav2F[Vf[^
//@@leg_prmFrp\
//@@arm_prmFrp\
//@@body_prmF̗p\
//@@step_infFs[Vp\
//@@arm_angFr֐߂̌Œpx
//@߂l
//@@[Vf[^
//**********************************************************
int Walk02::turnR_first(int servo_wav2[WAVE_MAX][12], struct LEG_PRM leg_prm[2],  struct ARM_PRM arm_prm[2],
				struct BODY_PRM body_prm, struct STEP_INF *step_inf,double arm_ang[2][3])
{
int		i, j, k, data_num, data_num2;

double	a, q, r, dist, cx, cz, l1, l2, l3;
double	coo[100];

double	coo_wav1[2][WAVE_MAX][3];
double	angle2[WAVE_MAX][2][2];

	//O_ϐ̏
	for(i = 0; i < step_inf->point_num * 2 + 1; i++)
		for(k = 0; k < 2; k++) coo_wav1[k][i][1] = 0.0;

	//ẼX^[gʒuiĂj
	coo_wav1[0][0][0] = step_inf->offset[0][0];
	coo_wav1[0][0][1] = step_inf->offset[0][1];
	coo_wav1[0][0][2] = step_inf->offset[0][2];

	//̃X^[gʒuiĂj
	coo_wav1[1][0][0] = step_inf->offset[1][0];
	coo_wav1[1][0][1] = step_inf->offset[1][1];
	coo_wav1[1][0][2] = step_inf->offset[1][2];

	//******************************************************************
	//O
	//ړoHvZ
	//グ镔i1/4~)
	l1 = 0.25 * PI * 2.0 * step_inf->v_diff;
	//𑗂镔
	l2 = step_inf->travel / 2.0 - l1;
	//낷(1/2~)
	l3 = PI * step_inf->v_diff / 2.0;

	//ۂ̈ړOՂ̒
	dist = l1 + l2 + l3;

	num_line_1Da(coo, dist, step_inf->point_num);

	//グ镔i1/4~)
	i = 1;
	r = step_inf->v_diff;
	cx = coo_wav1[1][0][0] + step_inf->v_diff;
	cz = coo_wav1[1][0][2] + 0.0;
	q = 0;
	while(coo[i] < l1)
	{
		q = coo[i] / r;//~ʂ̒Sp
		coo_wav1[1][i][0] = cx - r * cos(q);// X
		coo_wav1[1][i][2] = cz + r * sin(q);// Z
		i++;
	}

	//グ
	while(coo[i] < l1 + l2)
	{
		coo_wav1[1][i][0] = cx + (coo[i] - l1);// X
		coo_wav1[1][i][2] = cz + step_inf->v_diff;// Z
		i++;
	}

	//镔
	r = step_inf->v_diff / 2.0;
	cx = coo_wav1[1][0][0] + step_inf->travel / 2.0;
	cz = coo_wav1[1][0][2] + step_inf->v_diff / 2.0;
	while(i < step_inf->point_num)
	{
		q = (coo[i] - (l1 + l2)) / r;//~ʂ̒Sp
		coo_wav1[1][i][0] = cx + r * sin(q);// X
		coo_wav1[1][i][2] = cz + r * cos(q);// Z
		i++;
	}

	//******************************************************************
	//E
	//ړoHvZ
	dist = step_inf->travel / 2.0; 
	num_line_1Da(coo, dist, step_inf->point_num);

	//֑镔
	i = 1;
	cx = coo_wav1[0][0][0];
	cz = coo_wav1[0][0][2];
	while(i < step_inf->point_num)
	{
		coo_wav1[0][i][0] = cx - coo[i];// X
		coo_wav1[0][i][2] = cz;// Z
		i++;
	}

	//O_t@Cɏoi`FbNpj
	j = coo_fwrite("pen4.csv", coo_wav1, step_inf->point_num);

	//O_RCT[{o̓f[^ɕϊ
	i = orbit2servo_wav1(coo_wav1, angle2, &servo_wav2[0], step_inf->point_num, leg_prm);

	//T[{f[^ɃVtgBi㔼g̐Uoj
	wave_shift1(servo_wav2, step_inf->point_num * 2, step_inf->point_num / 4 * 3, step_inf->point_num);
	//*********************************************************************************
	//ݏoOɏ㔼gX
	dist = step_inf->swingL;
	num_line_1Da(coo, dist, step_inf->point_num);

	//㔼gUf[^}isj
	for(i = 0; i < step_inf->point_num; i++)
	{
		a = coo[i] / 180.0 * PI;
		servo_wav2[i][4] = angle2servo2(0, a, body_prm);
	}
	data_num  = step_inf->point_num;
	data_num2 = step_inf->point_num + step_inf->point_num;
	//*******************************************
	dist = - step_inf->swingL;
	num_line_1Da(coo, dist, step_inf->point_num);

	//㔼gUf[^}iAj
	j = 0;
	for(i = data_num; i < data_num2; i++)
	{
		a = (step_inf->swingL + coo[j])  / 180.0 * PI;
		servo_wav2[i][4] = angle2servo2(0, a, body_prm);
		j++;
	}

	//*********************************************************************************
	//r̃f[^}
	//̃sb`f[^͒Ƃ
	for(i = 0; i < data_num2; i++)
	{
		servo_wav2[i][5] = angle2servo2(1, 0.0, body_prm);
		k = 0;
		for(j = 6; j < 9; j++)
		{
			servo_wav2[i][j] = angle2servo3(k, arm_ang[0][k], arm_prm[0]);
			k++;
		}
		k = 0;
		for(j = 9; j < 12; j++)
		{
			servo_wav2[i][j] = angle2servo3(k, arm_ang[1][k], arm_prm[1]);
			k++;
		}
	}

	return(data_num2);
}

//**********************************************************
//@s[Vf[^쐬iEMn^Ō̈j
//@
//@@servo_wav2F[Vf[^
//@@leg_prmFrp\
//@@arm_prmFrp\
//@@body_prmF̗p\
//@@step_infFs[Vp\
//@@arm_angFr֐߂̌Œpx
//@߂l
//@@[Vf[^
//**********************************************************
int Walk02::turnR_last(int servo_wav2[WAVE_MAX][12], struct LEG_PRM leg_prm[2],  struct ARM_PRM arm_prm[2],
				struct BODY_PRM body_prm, struct STEP_INF *step_inf,double arm_ang[2][3])
{
int		i, j, k;

double	dist;
double	coo[100];
double	coo_wav1[2][WAVE_MAX][3];
double	angle2[WAVE_MAX][2][2];


	//O_ϐ̏
	for(i = 0; i < step_inf->point_num * 2 + 1; i++)
		for(k = 0; k < 2; k++) coo_wav1[k][i][1] = 0.0;

	//ẼX^[gʒuiOj
	coo_wav1[0][0][0] = step_inf->offset[0][0] - step_inf->travel / 2.0;
	coo_wav1[0][0][1] = step_inf->offset[0][1];
	coo_wav1[0][0][2] = step_inf->offset[0][2];

	//̃X^[gʒuij
	coo_wav1[1][0][0] = step_inf->offset[1][0] + step_inf->travel / 2.0;
	coo_wav1[1][0][1] = step_inf->offset[1][1];
	coo_wav1[1][0][2] = step_inf->offset[1][2];

	//******************************************************************
	//Ȋx
	//
	//ړoHvZ
	dist = step_inf->travel / 2.0;
	num_line_1Da(coo, dist, step_inf->point_num);

	i = 1;
	while(i < step_inf->point_num)
	{
		coo_wav1[1][i][0] = coo_wav1[1][0][0] - coo[i];// X
		coo_wav1[1][i][2] = coo_wav1[1][0][2];// Z
		i++;
	}

	//******************************************************************
	//EO
	//ړoHvZ
	i = 1;
	while(i < step_inf->point_num)
	{
		coo_wav1[0][i][0] = coo_wav1[0][0][0] + coo[i];// X
		coo_wav1[0][i][2] = coo_wav1[0][0][2];// Z
		i++;
	}

	//O_t@Cɏoi`FbNpj
	j = coo_fwrite("pen4.csv", coo_wav1, step_inf->point_num);

	//O_RCT[{o̓f[^ɕϊ
	i = orbit2servo_wav1(coo_wav1, angle2, &servo_wav2[0], step_inf->point_num, leg_prm);
	//*********************************************************************************
	//r̃f[^}
	//̃sb`f[^͒Ƃ
	for(i = 0; i < step_inf->point_num; i++)
	{
		servo_wav2[i][4] = angle2servo2(0, 0.0, body_prm);
		servo_wav2[i][5] = angle2servo2(1, 0.0, body_prm);
		k = 0;
		for(j = 6; j < 9; j++)
		{
			servo_wav2[i][j] = angle2servo3(k, arm_ang[0][k], arm_prm[0]);
			k++;
		}
		k = 0;
		for(j = 9; j < 12; j++)
		{
			servo_wav2[i][j] = angle2servo3(k, arm_ang[1][k], arm_prm[1]);
			k++;
		}
	}

	return(step_inf->point_num);
}